/**
 * Klasse zum Abspeichern eines Ortes mittels x und y Koordinate
 */
public class Loc {
    private int x;
    private int y;

    /**
     * Constructor für die Loc Klasse ohne Argumente
     * x und y werden auf 0 initialisiert
     */
    public Loc() {
        this(0,0);
    }

    /**
     * Constructor für die Loc Klasse mit Argumenten
     * x und y werden auf die übergebenen Werte gesetzt
     */
    public Loc(int x, int y) {
        this.x = x;
        this.y = y;
    }


    /**
     * Getter für x Wert
     */
    public int getX() {
        return x;
    }
    
    /**
     * Getter für y Wert
     */
    public int getY() {
        return y;
    }

    /**
     * Setter für x Wert
     */
    public void setX(int x) {
        this.x = x;
    }

    /**
     * Setter für y Wert
     */
    public void setY(int y) {
        this.y = y;
    }

    /**
     * Gibt den Abstand (Nach Pythagoras) zwischen diesem und einem anderen Loc Objekt zurück
     */
    public double distance(Loc l) {
        int dx = this.x - l.x;
        int dy = this.y - l.y;
        return Math.sqrt(dx * dx + dy * dy);
    }
    
    /**
     * Gibt die "Manhattan-Distanz" zwischen diesem und einem anderen Loc Objekt zurück
     */
    public int manhattanDistance(Loc l) {
        return Math.abs(this.x - l.x) + Math.abs(this.y - l.y);
    }
}
